#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <err.h>
#include <string.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>

#define EVER (;;)

#define PORT 1337

void signal_handler(int id)
{
	switch(id)
	{
		case SIGCHLD:
			wait(NULL);
			break;
	}
}

void process(void)
{
	size_t n;
	char buffer[255];
	bzero(buffer, sizeof(buffer));

	read(STDIN_FILENO, buffer, 1024);
	n = strlen(buffer);	
	write(STDOUT_FILENO, buffer, n);
}

int main(void)
{
	int socket_host, socket_client;
	struct sockaddr_in endpoint_def;
	socklen_t endpoint_len = sizeof(endpoint_def);

	if((socket_host = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		err(EXIT_FAILURE, "socket");
	}

	bzero(&endpoint_def, endpoint_len);
	endpoint_def.sin_port = htons(PORT);
	endpoint_def.sin_family = AF_INET;
	endpoint_def.sin_addr.s_addr = htonl(INADDR_ANY);

	if(bind(socket_host, (const struct sockaddr *)&endpoint_def, endpoint_len) != 0)
	{
		err(EXIT_FAILURE, "bind");
	}

	if(listen(socket_host, 20) != 0)
	{
		err(EXIT_FAILURE, "listen");
	}

	signal(SIGCHLD, signal_handler);

	for EVER
	{
		socket_client = accept(socket_host, NULL, NULL);
		
		if(socket_client >= 0)
		{
			switch(fork())
			{
				case -1:
					perror("fork");
					break;
			
				case 0:
					close(socket_host);
					setsid();
					dup2(socket_client, STDIN_FILENO);
					dup2(socket_client, STDOUT_FILENO);
					dup2(socket_client, STDERR_FILENO);
					process();
					close(socket_client);
					exit(EXIT_SUCCESS);

				default:
					close(socket_client);
					break;
			}
		}

		else
		{
			perror("accept");
		}
	}

	return 0;
}
